com.google.appengine.api.prospectivesearch.dev

## Class QueryEvaluator

- java.lang.Object
- - com.google.appengine.api.prospectivesearch.dev.QueryEvaluator

- All Implemented Interfaces:
    com.google.appengine.api.search.query.QueryTreeVisitor<com.google.appengine.api.prospectivesearch.dev.BooleanQueryContext>

      public class QueryEvaluator
      extends java.lang.Object
      implements com.google.appengine.api.search.query.QueryTreeVisitor<com.google.appengine.api.prospectivesearch.dev.BooleanQueryContext>

  The QueryEvaluator class performs a full visit of the query tree, dispatching leaf evaluations to the QueryEngine.

  Fine-grained debugging of query parsing is available at the logging level java.util.logging.Level.FINEST.

  Not multi-thread safe.

- - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `visitConjunction(Tree node, com.google.appengine.api.prospectivesearch.dev.BooleanQueryContext matches)` Visits a node that represents a conjunction (logical and) of conditions.
    `void` | `visitContains(Tree node, com.google.appengine.api.prospectivesearch.dev.BooleanQueryContext matches)` Visits a node that represents that a field must contain a value.
    `void` | `visitDisjunction(Tree node, com.google.appengine.api.prospectivesearch.dev.BooleanQueryContext matches)` Visits a node that represents a disjunction (logical or) of conditions.
    `void` | `visitEqual(Tree node, com.google.appengine.api.prospectivesearch.dev.BooleanQueryContext matches)` Visits a node that represents that a field value must be greater than or equal to some specified value.
    `void` | `visitFunction(Tree node, com.google.appengine.api.prospectivesearch.dev.BooleanQueryContext matches)` Visits a node that represents a function computed on some arguments.
    `void` | `visitFuzzy(Tree node, com.google.appengine.api.prospectivesearch.dev.BooleanQueryContext matches)` Visits a node that represents a text field that is subject to query rewrite.
    `void` | `visitGlobal(Tree node, com.google.appengine.api.prospectivesearch.dev.BooleanQueryContext matches)` Visits a node that represents a global field.
    `void` | `visitGreaterOrEqual(Tree node, com.google.appengine.api.prospectivesearch.dev.BooleanQueryContext matches)` Visits a node that represents an inequality between a field and value.
    `void` | `visitGreaterThan(Tree node, com.google.appengine.api.prospectivesearch.dev.BooleanQueryContext matches)` Visits a node that represents that a field value must be greater than some specified value.
    `void` | `visitLessOrEqual(Tree node, com.google.appengine.api.prospectivesearch.dev.BooleanQueryContext matches)` Visits a node that represents that a field value must be less than or equal to some specified value.
    `void` | `visitLessThan(Tree node, com.google.appengine.api.prospectivesearch.dev.BooleanQueryContext matches)` Visits a node that represents that a field value must be less than some specified value.
    `void` | `visitLiteral(Tree node, com.google.appengine.api.prospectivesearch.dev.BooleanQueryContext matches)` Visits a node that represents a text field that must not be altered.
    `void` | `visitNegation(Tree node, com.google.appengine.api.prospectivesearch.dev.BooleanQueryContext matches)` Visits a node that represents a negation of conditions.
    `void` | `visitOther(Tree node, com.google.appengine.api.prospectivesearch.dev.BooleanQueryContext matches)` Catch-all method for future type of query nodes.
    `void` | `visitSequence(Tree node, com.google.appengine.api.prospectivesearch.dev.BooleanQueryContext matches)` Visits a node that represents a sequence of expressions.
    `void` | `visitValue(Tree node, com.google.appengine.api.prospectivesearch.dev.BooleanQueryContext matches)` Visits a node that represents a constant value.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Method Detail

    - #### visitSequence

          public void visitSequence(Tree node,
                                    com.google.appengine.api.prospectivesearch.dev.BooleanQueryContext matches)

      Description copied from interface: `com.google.appengine.api.search.query.QueryTreeVisitor`
      Visits a node that represents a sequence of expressions.
      Specified by:
        `visitSequence` in interface `com.google.appengine.api.search.query.QueryTreeVisitor<com.google.appengine.api.prospectivesearch.dev.BooleanQueryContext>`

    - #### visitConjunction

          public void visitConjunction(Tree node,
                                       com.google.appengine.api.prospectivesearch.dev.BooleanQueryContext matches)

      Visits a node that represents a conjunction (logical and) of conditions.
      Specified by:
        `visitConjunction` in interface `com.google.appengine.api.search.query.QueryTreeVisitor<com.google.appengine.api.prospectivesearch.dev.BooleanQueryContext>`
      Parameters:
        `matches` - is set to the conjunction of node's sub-expressions

    - #### visitDisjunction

          public void visitDisjunction(Tree node,
                                       com.google.appengine.api.prospectivesearch.dev.BooleanQueryContext matches)

      Visits a node that represents a disjunction (logical or) of conditions.
      Specified by:
        `visitDisjunction` in interface `com.google.appengine.api.search.query.QueryTreeVisitor<com.google.appengine.api.prospectivesearch.dev.BooleanQueryContext>`
      Parameters:
        `matches` - is set to the disjunction of node's sub-expressions

    - #### visitNegation

          public void visitNegation(Tree node,
                                    com.google.appengine.api.prospectivesearch.dev.BooleanQueryContext matches)

      Visits a node that represents a negation of conditions.
      Specified by:
        `visitNegation` in interface `com.google.appengine.api.search.query.QueryTreeVisitor<com.google.appengine.api.prospectivesearch.dev.BooleanQueryContext>`
      Parameters:
        `matches` - is set to the negation of node's sub-expression

    - #### visitFuzzy

          public void visitFuzzy(Tree node,
                                 com.google.appengine.api.prospectivesearch.dev.BooleanQueryContext matches)

      Visits a node that represents a text field that is subject to query rewrite.
      Specified by:
        `visitFuzzy` in interface `com.google.appengine.api.search.query.QueryTreeVisitor<com.google.appengine.api.prospectivesearch.dev.BooleanQueryContext>`

    - #### visitLiteral

          public void visitLiteral(Tree node,
                                   com.google.appengine.api.prospectivesearch.dev.BooleanQueryContext matches)

      Visits a node that represents a text field that must not be altered.
      Specified by:
        `visitLiteral` in interface `com.google.appengine.api.search.query.QueryTreeVisitor<com.google.appengine.api.prospectivesearch.dev.BooleanQueryContext>`

    - #### visitLessThan

          public void visitLessThan(Tree node,
                                    com.google.appengine.api.prospectivesearch.dev.BooleanQueryContext matches)

      Visits a node that represents that a field value must be less than some specified value.
      Specified by:
        `visitLessThan` in interface `com.google.appengine.api.search.query.QueryTreeVisitor<com.google.appengine.api.prospectivesearch.dev.BooleanQueryContext>`

    - #### visitLessOrEqual

          public void visitLessOrEqual(Tree node,
                                       com.google.appengine.api.prospectivesearch.dev.BooleanQueryContext matches)

      Visits a node that represents that a field value must be less than or equal to some specified value.
      Specified by:
        `visitLessOrEqual` in interface `com.google.appengine.api.search.query.QueryTreeVisitor<com.google.appengine.api.prospectivesearch.dev.BooleanQueryContext>`

    - #### visitGreaterThan

          public void visitGreaterThan(Tree node,
                                       com.google.appengine.api.prospectivesearch.dev.BooleanQueryContext matches)

      Visits a node that represents that a field value must be greater than some specified value.
      Specified by:
        `visitGreaterThan` in interface `com.google.appengine.api.search.query.QueryTreeVisitor<com.google.appengine.api.prospectivesearch.dev.BooleanQueryContext>`

    - #### visitGreaterOrEqual

          public void visitGreaterOrEqual(Tree node,
                                          com.google.appengine.api.prospectivesearch.dev.BooleanQueryContext matches)

      Visits a node that represents an inequality between a field and value.
      Specified by:
        `visitGreaterOrEqual` in interface `com.google.appengine.api.search.query.QueryTreeVisitor<com.google.appengine.api.prospectivesearch.dev.BooleanQueryContext>`

    - #### visitEqual

          public void visitEqual(Tree node,
                                 com.google.appengine.api.prospectivesearch.dev.BooleanQueryContext matches)

      Visits a node that represents that a field value must be greater than or equal to some specified value.
      Specified by:
        `visitEqual` in interface `com.google.appengine.api.search.query.QueryTreeVisitor<com.google.appengine.api.prospectivesearch.dev.BooleanQueryContext>`

    - #### visitContains

          public void visitContains(Tree node,
                                    com.google.appengine.api.prospectivesearch.dev.BooleanQueryContext matches)

      Visits a node that represents that a field must contain a value.
      Specified by:
        `visitContains` in interface `com.google.appengine.api.search.query.QueryTreeVisitor<com.google.appengine.api.prospectivesearch.dev.BooleanQueryContext>`

    - #### visitValue

          public void visitValue(Tree node,
                                 com.google.appengine.api.prospectivesearch.dev.BooleanQueryContext matches)

      Visits a node that represents a constant value.
      Specified by:
        `visitValue` in interface `com.google.appengine.api.search.query.QueryTreeVisitor<com.google.appengine.api.prospectivesearch.dev.BooleanQueryContext>`

    - #### visitGlobal

          public void visitGlobal(Tree node,
                                  com.google.appengine.api.prospectivesearch.dev.BooleanQueryContext matches)

      Description copied from interface: `com.google.appengine.api.search.query.QueryTreeVisitor`
      Visits a node that represents a global field.
      Specified by:
        `visitGlobal` in interface `com.google.appengine.api.search.query.QueryTreeVisitor<com.google.appengine.api.prospectivesearch.dev.BooleanQueryContext>`

    - #### visitFunction

          public void visitFunction(Tree node,
                                    com.google.appengine.api.prospectivesearch.dev.BooleanQueryContext matches)

      Description copied from interface: `com.google.appengine.api.search.query.QueryTreeVisitor`
      Visits a node that represents a function computed on some arguments.
      Specified by:
        `visitFunction` in interface `com.google.appengine.api.search.query.QueryTreeVisitor<com.google.appengine.api.prospectivesearch.dev.BooleanQueryContext>`

    - #### visitOther

          public void visitOther(Tree node,
                                 com.google.appengine.api.prospectivesearch.dev.BooleanQueryContext matches)

      Catch-all method for future type of query nodes.
      Specified by:
        `visitOther` in interface `com.google.appengine.api.search.query.QueryTreeVisitor<com.google.appengine.api.prospectivesearch.dev.BooleanQueryContext>`